
using System;
using System.IO;

namespace Raster
{
	
	public class Raster
	{
		public int[,] content; //Array where are stored raster values.
		public int rows; //Hold number of rows. The variable is not necessary, but good for understanding how all works.
		public int cols; //Hold number of cols. The variable is not necessary, but good for understanding how all works.
		public Raster()
		{
		
		}
		public Raster(int rows, int cols)
		{
			content = new int[rows, cols];
			this.rows = rows;
			this.cols = cols;
		}
		/* Reads raster data from GRASS GIS ASCII RASTER file .
		 * Skips header except number of rows and cols.
		 * */
		public void readFromTexFile(String fileName) {
			FileStream fs = new FileStream(fileName, FileMode.Open);
			StreamReader sr = new StreamReader(fs);
			String line;
			//Skip the header
			for (int a=0; a<6; a++) {
				line = sr.ReadLine();
			}
			line = sr.ReadLine(); //cols
			//test if the row in the file contains number
			try {
			   cols = Int32.Parse(line.Substring(6).Trim()); 
		    } catch (System.FormatException ex) {
			   Console.WriteLine(ex.Message + ": " + line);
			}
			line = sr.ReadLine(); //rows
			rows = Int32.Parse(line.Substring(6).Trim());
			content = new int[rows, cols];
			int i = 0; //actual row
			//Reads all lines from file
			while ((line = sr.ReadLine()) != null) {
				//one line is splitted according to separator space to get values in array
				String[] items = line.Split(' ');
				for (int j=0; j<cols; j++) {
					try {
					    content[i,j] = Int32.Parse(items[j]);
					} catch (System.FormatException ex) {
						Console.WriteLine(ex.Message + ": " + i + " " + j + " " + items[j]);
						
					}
					//Console.WriteLine(i + " " + j + " " + items[j]);
				}
				i++;
			}
			sr.Close();
		}
		/* Writes content of an array content to the text file. 
		 * Header for GRASS GIS ASCII Raster is omitted. */
		public void writeToTextFile(String fileName) {
			//FileStream fs = new FileStream(fileName, FileMode.Create);
			StreamWriter sw = new StreamWriter(fileName);
			for (int i=0; i<rows; i++) {
				for (int j=0; j<cols; j++) {
					 sw.Write(content[i,j] + " ");
					
				}	
				sw.WriteLine();
				sw.Flush(); //Flush one line to the file. 
			}
			sw.Close(); //Flush remaining content of the buffer to the file.
		} 
		
		/* Calculates mapcals sum operation between two rasters.
		 * One raster is this objects. Second raster is parameter of the method. 
		 * Output raster is returned from the method. */
		public Raster sum(Raster r) {
			Raster output = new Raster(rows, cols);
			Console.WriteLine("Content");
			for (int i=0; i<rows; i++) {
				for (int j=0; j<cols; j++) {
					//int pom = content[i,j] + r.content[i,j];
					output.content[i,j] = content[i,j] + r.content[i,j];
					Console.WriteLine(output.content[i,j]);
				}	
				
			}
			return output;
		}
	}
}
